function NNErr=DL(SH,SW)

DataPath='Data90_78\';

dsall=dir([DataPath,'*']);
dsall(1:2,:)=[];

icol=90;
irow=78;

gindx=0;
pindx=0;
gndindx=0;
GallaryIndex(1,1)=1;
ProbeIndex(1,1)=1;
for i=1:length(dsall)
    dsp=[];
    dsp=dir([DataPath,dsall(i,1).name,'\*.tif']);
    if (length(dsp)>=20) 
            gndindx=gndindx+1;
            if gndindx>1
                GallaryIndex(gndindx,1)=GallaryIndex(gndindx-1,2)+1;
                ProbeIndex(gndindx,1)=ProbeIndex(gndindx-1,2)+1;
            end
            GallaryIndex(gndindx,2)=GallaryIndex(gndindx,1)+10-1; 
            ProbeIndex(gndindx,2)=ProbeIndex(gndindx,1)+10-1; 
            for j=1:10 
                gindx=gindx+1;
                I=[];
                I=imread([DataPath,dsall(i,1).name,'\',dsp(j,1).name]);
                I=histeq(I);
                if (SH~=irow) || (SW~=icol)
                    I=imresize(double(I),[SH SW],'bicubic');
                end
                AllGallary(:,:,gindx)=double((I));
                gndGallary(gindx)=gndindx;
            end
            for j=length(dsp)-10+1:length(dsp)           
                pindx=pindx+1;
                I=[];
                 I=imread([DataPath,dsall(i,1).name,'\',dsp(j,1).name]);
                I=histeq(I);
                if (SH~=irow) || (SW~=icol)
                    I=imresize(double(I),[SH SW],'bicubic');
                end
                AllProbe(:,:,pindx)=double((I));

                gndProbe(pindx)=gndindx;
            end
    end
end
nindx=[];
nindx=(AllGallary<0);
AllGallary(nindx)=0;
nindx=[];
nindx=(AllProbe<0);
AllProbe(nindx)=0;
clear nindx;
            
numimgs_gallary=size(AllGallary,3);

numimgs_test=size(AllProbe,3);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%I try to find all the correct answers here,
%so that, if I do not need output, I can easily 
%check the anwers
AnswerSheet=false(gndindx,gndindx);
for i=1:gndindx
            AnswerSheet(i,i)=true;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


[nR,nC,nSmp]=size(AllGallary);

trains=double((squeeze(reshape(AllGallary,[nR*nC 1 nSmp])))');

[nR,nC,nSmp]=size(AllProbe);
tests=double((squeeze(reshape(AllProbe,[nR*nC 1 nSmp])))');

clear AllGallary AllProbe

for i=1:size(trains,1)
		trains(i,:)=trains(i,:)./ max(1e-12,norm(trains(i,:)));
end

for i=1:size(tests,1)
		tests(i,:)=tests(i,:)./ max(1e-12,norm(tests(i,:)));
end
 
       		 GallaryWindow = trains;
                 TestWindow = tests;
	         
		 distMatrix=zeros(gndindx,gndindx);

		        for i=1:gndindx
                            Gsize=GallaryIndex(i,2)-GallaryIndex(i,1)+1;
                            X=(GallaryWindow(GallaryIndex(i,1):GallaryIndex(i,2),:))';
                        	Xs=-X(:,1:Gsize-1)+repmat(X(:,Gsize),1,Gsize-1);
                        	Xlast=X(:,Gsize);
            		    	X=[];
                        	for j=1:gndindx
                                    TSize=ProbeIndex(j,2)-ProbeIndex(j,1)+1;
                                	Y=(TestWindow(ProbeIndex(j,1):ProbeIndex(j,2),:))';
                            		Ys=Y(:,1:TSize-1)-repmat(Y(:,TSize),1,TSize-1);
                            		Ylast=Y(:,TSize);
                            		Y=[];
                            		YsXs=[Ys,Xs];
                            		Ys=[];
                            		H_Hat=YsXs*inv(YsXs'*YsXs)*YsXs';
                            		YsXs=[];
                            		XlYl=Xlast-Ylast;
                            		Ylast=[];
                            		distMatrix(i,j)=(norm((XlYl-H_Hat*XlYl))).^2;
                            end
                	end
                    
	 MT=min(distMatrix,[],1);
	 IndexofMT=find(distMatrix<=repmat(MT+eps,gndindx,1));
	 NNAnswer=zeros(gndindx,gndindx);
	 NNAnswer(IndexofMT)=1;
	 counteachprobe=sum(NNAnswer,1);
	 NNAnswer=NNAnswer./repmat(counteachprobe,gndindx,1);
	 NNrightanswer= sum(sum(AnswerSheet.*NNAnswer));
	 NNErr=(1-NNrightanswer/gndindx); %*100;
