function DL
FileDir='DataSet';

warning off;

FL=40; %First FL frames used. This number should be significantly smaller than 50. 

load([FileDir,'/','YouTubeTrackedFaces_HE_resized10x10.mat']);

ImgDataHeqResized=ImgData; 
ImgData=[];

for i=1:length(ImgDataHeqResized)
	if size(ImgDataHeqResized{i},2)>FL
        	ImgDataHeqResized{i}(:,FL+1:size(ImgDataHeqResized{i},2))=[];
    	end
	for k=1:size(ImgDataHeqResized{i},2)
		I=ImgDataHeqResized{i}(:,k);
		NORMC=norm(I);
		if NORMC~=0
			I=I/NORMC;
		else
			I(:)=1/sqrt(length(I));
		end
		ImgDataHeqResized{1,i}(:,k)=I;
	end
end

DM=zeros(length(ImgDataHeqResized),length(ImgDataHeqResized));

for i=1:length(ImgDataHeqResized)
    img=i
	X=ImgDataHeqResized{i};
	Xs=-X(:,1:size(X,2)-1)+repmat(X(:,size(X,2)),1,size(X,2)-1);
	Xlast=X(:,size(X,2));
	X=[];
	for j=i+1:length(ImgDataHeqResized)   
		%The distance between a pair of videos are symetic indeed, 
		%if you want try, you can let j starts with 1
		%then you should comment out the DM=DM+DM' near the bottom 
		%of the code -- then your running time will be doubled
		Y=ImgDataHeqResized{j};
		Ys=Y(:,1:size(Y,2)-1)-repmat(Y(:,size(Y,2)),1,size(Y,2)-1);
        	Ylast=Y(:,size(Y,2));
		Y=[];
		YsXs=[Ys,Xs];
                Ys=[];
                H_Hat=YsXs*inv(YsXs'*YsXs)*YsXs';
                YsXs=[];
                XlYl=Xlast-Ylast;
                Ylast=[];
                DM(i,j)=norm((XlYl-H_Hat*XlYl));
	end
end

DM=DM+DM'; 

mkdir('DistanceMatrix');
save([FileDir,'/DM10x10.mat'],'DM','SizeArr','Categories');
end
